module cpu_code

contains

subroutine eval(a,b,c,size)
  implicit none
  real, dimension(0:size-1) :: a,c
  real :: b
  integer :: size,i
  do i = 0, size-1
    c(i)=a(i)*b;
  end do
end subroutine eval

end module cpu_code

program exercise01

use cpu_code
implicit none

! define vector size !
integer, parameter :: vector_size = 10000
real, dimension(0:vector_size-1) :: vector_a
real, dimension(0:vector_size-1) :: vector_c
real :: b
integer :: i
logical :: success
integer :: error

call random_seed()

call random_number(b)

! initialize input vector to 0 !
do i=0,vector_size-1
  call random_number(vector_a(i))
end do
! initialize output vector to 0 !
do i=0,vector_size-1
  vector_c(i)=0;
end do


call eval(vector_a,b,vector_c,vector_size)

! verify results !
success=.true.
do i=0,vector_size-1
  if (abs(vector_a(i)*b-vector_c(i))>1e-5*b) then
    print *,'computation result is wrong: index=',i, &
        ' expected result=',vector_a(i)*b, &      
        'cuda result=', vector_c(i)
    success=.false.
    exit
  end if
end do
if (success) then
  print *,'computation result is correct.'
end if

end program exercise01
