#include <stdio.h>
#include <malloc.h>

float ScalarProduct(float* a,float* b,int size) {
  float sum=0;
  for( int i=0;i<size;i++) {
    sum += a[i] * b[i];
  }
  return sum;
}

// CPU code //
int main() {
  // define vector size //
  const int vector_size = 1000;

  // allocate memory //
  float* vectorA = (float*)malloc(vector_size*sizeof(float));
  float* vectorB = (float*)malloc(vector_size*sizeof(float));

  // initialize vector //
  for(int i=0;i<vector_size;i++) {
    vectorA[i]=1.f/(1.f+i);
    vectorB[i]=1.f+i;
  }

  // call computation function
  float result=ScalarProduct(vectorA,vectorB,vector_size);

  // print results //
  printf("result=%.5f\n",result);

  // free memory //
  free(vectorA);
  free(vectorB);

  // exit //
  return 0;
}
