module cpu_code

contains

subroutine ScalarProduct(a,b,result,size)
  implicit none
  real, dimension(0:size-1) :: a,b
  real :: result
  real :: sum
  integer, value :: size
  integer :: i
  sum=0
  do i=0,size-1
     sum=sum+a(i)*b(i)
  end do
  result = sum
end subroutine ScalarProduct

end module cpu_code

program exercise05

use cpu_code

implicit none

! define vector size !
integer, parameter :: vector_size = 10000
real, dimension(0:vector_size-1) :: vector_a
real, dimension(0:vector_size-1) :: vector_b
real :: result
real(kind=8) :: timer1,timer2,duration
integer :: i
logical :: success
integer :: error

! CPU code !

call random_seed()

! initialize cpu input vector to 0 !
do i=0,vector_size-1
  vector_a(i)=1./(1.+i)
  vector_b(i)=1.+i
end do

result=0

call cpu_time(timer1)
call ScalarProduct(vector_a,vector_b,result,vector_size)
call cpu_time(timer2)
duration=timer2-timer1

print *,'result=', result

print *,'duration=',duration,' seconds, performance = ',vector_size*2./duration,' FLOPS'
print *,'memory bandwidth = ',vector_size*8./duration,' bytes/s'

end program exercise05
