module cpu_code

contains

subroutine MatrixProd(a,b,c,m,n,p)
  implicit none
  integer, value :: m,n,p
  real, dimension(0:m*n-1), intent(in) :: a
  real, dimension(0:n*p-1), intent(in) :: b
  real, dimension(0:m*p-1), intent(inout) :: c
  real :: sum
  integer :: i,j,k,a_line_index
  do i=0,m-1
    a_line_index=i*n
    do j=0,p-1
      sum=0
      do k=0,n-1
        sum=sum+a(a_line_index+k)*b(k*p+j)
      end do
      c(i*p+j)=sum
    end do
  end do
end subroutine MatrixProd

end module cpu_code

program exercise08

use cpu_code

implicit none

! define vector size !
integer, parameter :: size_m = 450
integer, parameter :: size_n = 350
integer, parameter :: size_p = 400
integer, parameter :: matrix_a_size = size_m*size_n
integer, parameter :: matrix_b_size = size_n*size_p
integer, parameter :: matrix_c_size = size_m*size_p
real, dimension(0:matrix_a_size-1) :: matrix_a
real, dimension(0:matrix_b_size-1) :: matrix_b
real, dimension(0:matrix_c_size-1) :: matrix_c
real(kind=8) :: timer1, timer2,duration
integer :: i,j
logical :: success
integer :: error

! CPU code !

call random_seed()

! initialize input matrices to random values !
do i=0,matrix_a_size-1
   call random_number(matrix_a(i))
end do
do i=0,matrix_b_size-1
   call random_number(matrix_b(i))
end do
! initialize output matrix to -1 !
matrix_c=-1

call cpu_time(timer1)
call MatrixProd(matrix_a,matrix_b,matrix_c,size_m,size_n,size_p)
call cpu_time(timer2)

! print results !
print *,matrix_c

duration=timer2-timer1
print *,'duration(computation on CPU)=',duration,' seconds, performance = ',2.*size_m*size_n*size_p/duration,' FLOPS'

end program exercise08
